public class DemoSieveOfEratosthenes {

   boolean[] createSieve(int max) {
      boolean[] sieve = new boolean[max + 1];
      for (int i = 2; i <= max; ++i) {
         sieve[i] = true;
      }
      int p = 2;
      int pmax = (int)Math.sqrt(max);
      do {
         for(int i = p + p; i <= max; i += p) {
            sieve[i] = false;
         }
         do {
            p++;
         } while (!sieve[p]);
      } while (p <= pmax);
      return sieve;
   }

   void print(boolean[] sieve) {
      for(int i = 2; i < sieve.length; ++i) {
         if (sieve[i]) {
            System.out.print(i + " ");
         }
      }
   }

   void start(int max) {
      boolean[] sieve = createSieve(max);
      System.out.print("Prime numbers from 2 to " + max + ": ");
      print(sieve);
      System.out.println("");
   }

   public static void main(String[] args) {
      DemoSieveOfEratosthenes demo = new DemoSieveOfEratosthenes();
      demo.start(args.length > 0 ? Integer.parseInt(args[0]) : 100);
   }

}
